/*
Silver Tokens!
Emblem replacements for Multiplayer.
Collecting all of them in a given stage rewards an extra Emerald Token.

Writen by: Mylo T.
Assistance by: felixlumyni
*/

freeslot(
"MT_SILVERTOKEN",
"S_SILVERTOKEN",
"SPR_SVTK",
"sfx_svtkcl",
"sfx_svtkan",
"sfx_svtkas"
)

sfxinfo[sfx_svtkcl].caption = "Got Silver Token"
sfxinfo[sfx_svtkan].caption = "Got 'Em All!"
sfxinfo[sfx_svtkas].caption = "\131~\130Got 'Em All!\131~\128"

mobjinfo[MT_SILVERTOKEN] = {
	//$Title SilverToken
	//$Category EX Utility
	//$Sprite SVTKA0
	//$NotAngled
	doomednum = 3258,
	spawnstate = S_SILVERTOKEN,
	radius = 8*FRACUNIT,
	height = 16*FRACUNIT,
	spawnhealth = 1000,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_SPECIAL|MF_NOCLIPHEIGHT
}

states[S_SILVERTOKEN] = {
	sprite = SPR_SVTK,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE,
	tics = -1,
	var1 = 19,
	var2 = 1,
	nextstate = S_SILVERTOKEN
}

local SilverTokensTotal = 0
local SilverTokensHeld = 0

addHook("NetVars", function(network)
    SilverTokensHeld = network(SilverTokensHeld)
	SilverTokensTotal = network(SilverTokensTotal)
end)

addHook("MapLoad",function()
	if not multiplayer then return end --Don't spawn in singleplayer.
	SilverTokensTotal = 0
	SilverTokensHeld = 0
	if (gametype == GT_COOP) --Only run the system if we're in COOP, but reset the variables regardless just to be safe.
		for mapt in mapthings.iterate
			if mapt.type == 322
				local x = mapt.x*FRACUNIT
				local y = mapt.y*FRACUNIT
				
				local floor = R_PointInSubsector(x, y).sector.floorheight
				local slope = R_PointInSubsectorOrNil(x,y).sector.f_slope
				
				if slope != nil
					floor = P_GetZAt(slope,x,y)
				end
				
				local z = floor + 32*FRACUNIT + mapt.z*FRACUNIT
				
				P_SpawnMobj(x, y, z, MT_SILVERTOKEN)
				SilverTokensTotal = $ + 1
			end
		end
	end
end)

addHook("TouchSpecial", function(special, toucher)
    P_AddPlayerScore(toucher.player, 1000)
    SilverTokensHeld = $ + 1
    if SilverTokensHeld == SilverTokensTotal
        if All7Emeralds(emeralds) then --Got all Silver Tokens WITH Chaos Emeralds.
            S_StartSound(nil, sfx_svtkas)
            P_GivePlayerRings(toucher.player, 50)
        else --Got all Silver Tokens WITHOUT Chaos Emeralds.
            S_StartSound(nil, sfx_svtkan)
            P_SpawnMobj(toucher.x, toucher.y, toucher.z, MT_TOKEN)
        end
    else
        S_StartSound(special.mo, sfx_svtkcl)
    end
end, MT_SILVERTOKEN)

//Draw the current held token count on the hud!
hud.add(function(v)
	local flags = 0
	if SilverTokensHeld >0 then
		if SilverTokensHeld == SilverTokensTotal then flags = V_GREENMAP end
		v.drawScaled(192*FRACUNIT, 14*FRACUNIT, FRACUNIT-FRACUNIT/2, v.cachePatch("SVTKICON"), V_SNAPTOTOP|V_HUDTRANS)
		v.drawString(211, 10, "-", flags)
		v.drawString(221, 10, tostring(SilverTokensHeld), flags)
	end
end, "scores")

//Debug Stuff
COM_AddCommand("debug_silvertokencount",function(p)
	if (IsPlayerAdmin(p) or #p == 0)
		CONS_Printf(p,"\130Total Tokens:", SilverTokensTotal)
		CONS_Printf(p,"\131Tokens Collected:", SilverTokensHeld)
	end
end)

//Delete Emblems in Multiplayer because we have a custom object replacing them.
addHook("MobjThinker", function(mobj)
	if not multiplayer then return end
	mobj.state = S_NULL
end, MT_EMBLEM)